package com.exquisiteapplicationsolutions.tis;

import android.content.Context;
import android.util.Log;

import com.exquisiteapplicationsolutions.tis.objects.MessagesClass;

import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by cairnsj on 6/8/15.
 */
public class CommunicationsClass {

    private static final String sDBName = "TIS.db";
    private static final int iVersionVal = 1;
    public Context oContext;
    private static ArrayList<ArrayList<String>> messageArray;

    public MessagesClass read(String sRecID) {
        MessagesClass oRtnVal = new MessagesClass();

        TISDBHelper oDB = new TISDBHelper(oContext, sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "Select FromUserFullName, MsgStatus, MsgID, MsgDate, Title, Message, FromUserFullName, FromUserName, ToUserName, _id ";
            sSQL += "from Messages ";
            sSQL += " where _id =  " + sRecID;
            Log.d("sSQL", sSQL);
            messageArray = oDB.selectRecordsFromDBList(sSQL, null);
        } catch (IOException ex) {
            DBLogs.insert("Error: " + ex.toString(),
                "CommunicationsClass.MessageClass.read",
                oContext, sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
        if (messageArray.size() > 0) {
            DateConvertClass oDateConvert = new DateConvertClass();
            oDateConvert.oContext = oContext;
            for (ArrayList<String> sValue : messageArray) {
                oRtnVal.FromUserFullName = sValue.get(0);
                oRtnVal.MsgStatus = sValue.get(1);
                oRtnVal.MsgID = sValue.get(2);
                oRtnVal.MsgDate = oDateConvert.GMTToLocal(sValue.get(3));
                oRtnVal.Title = sValue.get(4);
                oRtnVal.Message = sValue.get(5);
                oRtnVal.FromUserFullName = sValue.get(6);
                oRtnVal.FromUserName = sValue.get(7);
                oRtnVal.ToUserName = sValue.get(8);
                oRtnVal.id = sValue.get(9);
            }
        }

        return oRtnVal;
    }

    //Need this as a seperate read since we do not want to modify the date when sending to the server.
    public MessagesClass sendToServer(String sRecID) {
        MessagesClass oRtnVal = new MessagesClass();

        TISDBHelper oDB = new TISDBHelper(oContext, sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "Select FromUserFullName, MsgStatus, MsgID, MsgDate, Title, Message, FromUserFullName, FromUserName, ToUserName, _id ";
            sSQL += "from Messages ";
            sSQL += " where _id =  " + sRecID;
            Log.d("sSQL", sSQL);
            messageArray = oDB.selectRecordsFromDBList(sSQL, null);
        } catch (IOException ex) {
            DBLogs.insert("Error: " + ex.toString(),
                    "CommunicationsClass.MessageClass.read",
                    oContext, sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
        if (messageArray.size() > 0) {
            DateConvertClass oDateConvert = new DateConvertClass();
            oDateConvert.oContext = oContext;
            for (ArrayList<String> sValue : messageArray) {
                oRtnVal.FromUserFullName = sValue.get(0);
                oRtnVal.MsgStatus = sValue.get(1);
                oRtnVal.MsgID = sValue.get(2);
                oRtnVal.MsgDate = sValue.get(3);
                oRtnVal.Title = sValue.get(4);
                oRtnVal.Message = sValue.get(5);
                oRtnVal.FromUserFullName = sValue.get(6);
                oRtnVal.FromUserName = sValue.get(7);
                oRtnVal.ToUserName = sValue.get(8);
                oRtnVal.id = sValue.get(9);
            }
        }

        return oRtnVal;
    }
}
