package com.exquisiteapplicationsolutions.tis.activities;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.exquisiteapplicationsolutions.tis.DBLogs;
import com.exquisiteapplicationsolutions.tis.R;
import com.exquisiteapplicationsolutions.tis.TISDBHelper;

import java.io.IOException;
import java.util.ArrayList;


public class AboutActivity extends Activity {
    private static final String sDBName = "TIS.db";
    private static final int iVersionVal = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_about);

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sCurrentVersion = prefs.getString("TISVersion", "No Value");
        TextView tvVersion = (TextView) findViewById(R.id.tvVersion);
        String sVersionText = tvVersion.getText().toString();
        sVersionText = sVersionText.replace("RELNUM",sCurrentVersion);
        TextView tvOSVersion = (TextView) findViewById(R.id.tvOSVersion);
        String sOSVersionText = tvOSVersion.getText().toString();
        sOSVersionText = sOSVersionText.replace("OSVERSIONNUM",android.os.Build.VERSION.RELEASE);
        TextView tvDeviceName = (TextView) findViewById(R.id.tvDeviceName);
        String sDeviceNameText = tvDeviceName.getText().toString();
        sDeviceNameText = sDeviceNameText.replace("DEVICENAME",android.os.Build.MODEL);
        TextView tvDeviceManufactrer = (TextView) findViewById(R.id.tvDeviceManufacturer);
        String sDeviceManufactrerText = tvDeviceManufactrer.getText().toString();
        sDeviceManufactrerText = sDeviceManufactrerText.replace("DEVICEMANUFACTURER",android.os.Build.MANUFACTURER);
        TextView tvDeviceSerial = (TextView) findViewById(R.id.tvDeviceSerial);
        String sDeviceSerialText = tvDeviceSerial.getText().toString();
        sDeviceSerialText = sDeviceSerialText.replace("SERIALNUM",android.os.Build.SERIAL);
        final String sSupportPhone = getSupportNumber();



        tvVersion.setText(sVersionText);
        tvOSVersion.setText(sOSVersionText);
        tvDeviceName.setText(sDeviceNameText);
        tvDeviceManufactrer.setText(sDeviceManufactrerText);
        tvDeviceSerial.setText(sDeviceSerialText);

        Button btnOK = (Button) findViewById(R.id.btnOK);
        btnOK.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
            }
        });

        TextView otvSupportNumber = (TextView) findViewById(R.id.tvSupportNumber);
        String sSupportPhoneFormatted = "";
        String sSupportUnknown = getString(R.string.support_number);
        if (!sSupportPhone.equals(sSupportUnknown)) {
            sSupportPhoneFormatted = "(" + sSupportPhone.substring(0, 3) + ")" + sSupportPhone.substring(3, 6) + "-" + sSupportPhone.substring(6, 10);
        } else {
            sSupportPhoneFormatted = sSupportPhone;
        }
        otvSupportNumber.setText(sSupportPhoneFormatted);
        otvSupportNumber.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                dialPhone(sSupportPhone);
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_about, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private String getSupportNumber() {
        ArrayList<ArrayList<String>> sStringList = null;
        TISDBHelper oDB = new TISDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        String sReturnValue = "unknown";
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            String sSQL = "select Value from Parameters where Name = 'supportPhone'";
            sStringList = oDB.selectRecordsFromDBList(sSQL, null);
            if (sStringList.size() > 0) {
                sReturnValue = sStringList.get(0).get(0).toString();
            }
        } catch (IOException ioe) {
            DBLogs.insert("Database Exception " + ioe.getMessage(),
                    "AboutActivity.getSupportNumber",
                    getApplicationContext(), sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
        if (sReturnValue.toLowerCase().equals("unknown")) {
            sReturnValue = getString(R.string.support_number);
        }
        return sReturnValue;
    }
    private void dialPhone(String sPhoneNumber) {
        Intent callIntent = new Intent(Intent.ACTION_CALL);
        callIntent.setData(Uri.parse("tel:" + sPhoneNumber));
        startActivity(callIntent );
    }

}
