package com.exquisiteapplicationsolutions.tis.activities;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.content.Context;
import android.database.sqlite.SQLiteException;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.Fragment;
import android.text.format.DateFormat;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TimePicker;

import com.exquisiteapplicationsolutions.tis.DBLogs;
import com.exquisiteapplicationsolutions.tis.DateConvertClass;
import com.exquisiteapplicationsolutions.tis.R;
import com.exquisiteapplicationsolutions.tis.TISDBHelper;
import com.exquisiteapplicationsolutions.tis.objects.SpinnerObj;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

/**
 * Created by jnissley on 3/5/16.
 */
public class CreateJobMainFragment extends Fragment implements View.OnClickListener {
    private final String sDBName = "TIS.db";
    private final int iVersionVal = 1;
    private static OnDataPass dataPasser;
    private static EditText etCreateJobNumber; //Required
    private static EditText etCreatePickupDate; //Required
    private static EditText etCreatePickupTime; //Required
    private static EditText etCreateDeliverDate; //Required
    private static EditText etCreateDeliverTime; //Required
    private static EditText etCreateCustomerRefNum;
    private static EditText etCreateContainerNum;
    private static EditText etCreateEntryNum;
    private static EditText etCreateCargoWeight;
    private static Spinner spCreateCargoWeightType;
    private static EditText etCreateManifestNum;

    private ArrayList<SpinnerObj> sSpinnerFieldList;
    private Context oContext;

    public CreateJobMainFragment() {
    }

    public CreateJobMainFragment newInstance() {
        CreateJobMainFragment fragment = new CreateJobMainFragment();
        return fragment;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_create_job_main, container, false);
        oContext = getActivity().getApplicationContext();
        etCreateJobNumber = (EditText) rootView.findViewById(R.id.etCreateJobNumberText);
        etCreatePickupDate = (EditText) rootView.findViewById(R.id.etCreatePickupDatetext);
        etCreatePickupDate.setOnClickListener(this);
        etCreatePickupTime = (EditText) rootView.findViewById(R.id.etCreatePickupTimetext);
        etCreatePickupTime.setOnClickListener(this);
        etCreateDeliverDate = (EditText) rootView.findViewById(R.id.etCreateDeliverDatetext);
        etCreateDeliverDate.setOnClickListener(this);
        etCreateDeliverTime = (EditText) rootView.findViewById(R.id.etCreateDeliverTimetext);
        etCreateDeliverTime.setOnClickListener(this);
        etCreateCustomerRefNum = (EditText) rootView.findViewById(R.id.etCreateCustomerRefNumText);
        etCreateContainerNum = (EditText) rootView.findViewById(R.id.etCreateContainerNumText);
        etCreateEntryNum = (EditText) rootView.findViewById(R.id.etCreateEntryNumText);
        etCreateCargoWeight = (EditText) rootView.findViewById(R.id.etCreateCargoWeightText);
        spCreateCargoWeightType = (Spinner) rootView.findViewById(R.id.spCreateCargoWeightType);
        etCreateManifestNum = (EditText) rootView.findViewById((R.id.etCreateManifestNumText));
        sSpinnerFieldList = new ArrayList<SpinnerObj>();
        getWeightType(oContext);
        ArrayAdapter<SpinnerObj> spinnerArrayAdapter =
                new ArrayAdapter<SpinnerObj>(this.getActivity(), R.layout.create_job_spinner_item, sSpinnerFieldList);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spCreateCargoWeightType.setAdapter(spinnerArrayAdapter);
        spCreateCargoWeightType.setOnTouchListener(spinnerOnTouch);

        return rootView;
    }

    //Detect if the fragment is losing focus so we can send the fragment data to the parent activity
    @Override
    public void setUserVisibleHint(boolean isVisibleToUser) {
        super.setUserVisibleHint(isVisibleToUser);

        // Make sure that we are currently visible
        if (this.isVisible()) {
            // If we are becoming invisible, then...
            if (!isVisibleToUser) {
                //Hide the soft keyboard
                final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
                //Bundle bValues = createAndSave();
                Bundle bValues = createAndSave();
                dataPasser.onDataPass("Main", bValues);
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.etCreatePickupDatetext) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            DialogFragment newFragment = new SelectDateFragment();
            newFragment.show(getFragmentManager(), "PickupDate");
        }
        if (v.getId() == R.id.etCreatePickupTimetext) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            DialogFragment newFragment = new SelectTimeFragment();
            newFragment.show(getFragmentManager(), "PickupTime");
        }
        if (v.getId() == R.id.etCreateDeliverDatetext) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            DialogFragment newFragment = new SelectDateFragment();
            newFragment.show(getFragmentManager(), "DeliveryDate");
        }
        if (v.getId() == R.id.etCreateDeliverTimetext) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            DialogFragment newFragment = new SelectTimeFragment();
            newFragment.show(getFragmentManager(), "DeliveryTime");
        }
    }

    @Override
    public void onAttach(Activity a) {
        super.onAttach(a);
        try {
            dataPasser = (OnDataPass) a;
        } catch (ClassCastException ex) {
            throw new ClassCastException(a.toString()
                    + " must implement OnHeadlineSelectedListener");
        }
    }

    private View.OnTouchListener spinnerOnTouch = new View.OnTouchListener() {
        //Hide the keyboard when the spinner is touched
        @Override
        public boolean onTouch(View v, MotionEvent event) {
            //Hide the soft keyboard
            final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            return false;
        }
    };

    public interface OnDataPass {
        public void onDataPass(String FragmentName, Bundle data);
    }

    public static class SelectDateFragment extends DialogFragment implements DatePickerDialog.OnDateSetListener {

        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) {
            final Calendar calendar = Calendar.getInstance();
            int yy = calendar.get(Calendar.YEAR);
            int mm = calendar.get(Calendar.MONTH);
            int dd = calendar.get(Calendar.DAY_OF_MONTH);
            Calendar minDate = Calendar.getInstance();
            minDate.setTime(new Date());
            minDate.add(Calendar.DATE, -1);
            Long lMinDate = minDate.getTimeInMillis();
            Calendar maxDate = Calendar.getInstance();
            maxDate.setTime(new Date());
            maxDate.add(Calendar.DATE, 10);
            Long lMaxDate = maxDate.getTimeInMillis();
            DatePickerDialog datePicker = new DatePickerDialog(getActivity(), this, yy, mm, dd);
            datePicker.getDatePicker().setMinDate(lMinDate);
            datePicker.getDatePicker().setMaxDate(lMaxDate);
            return datePicker;
        }

        public void onDateSet(DatePicker view, int yy, int mm, int dd) {
            if (this.getTag().equals("PickupDate")) {
                populateSetPickupDate(yy, mm + 1, dd);
            }
            if (this.getTag().equals("DeliveryDate")) {
                populateSetDeliveryDate(yy, mm + 1, dd);
            }
        }

        public void populateSetPickupDate(int year, int month, int day) {
            DateConvertClass oDate = new DateConvertClass();
            oDate.oContext = getActivity().getApplicationContext();
            etCreatePickupDate.setText(oDate.FormatDateOnly(year, month, day));
        }

        public void populateSetDeliveryDate(int year, int month, int day) {
            DateConvertClass oDate = new DateConvertClass();
            oDate.oContext = getActivity().getApplicationContext();
            etCreateDeliverDate.setText(oDate.FormatDateOnly(year, month, day));
        }
    }

    public static class SelectTimeFragment extends DialogFragment implements TimePickerDialog.OnTimeSetListener {
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) {
            final Calendar calendar = Calendar.getInstance();
            int hour = calendar.get(Calendar.HOUR_OF_DAY);
            int minute = calendar.get(Calendar.MINUTE);

            return new TimePickerDialog(getActivity(), this, hour, minute, DateFormat.is24HourFormat(getActivity()));
        }

        public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
            if (this.getTag().equals("PickupTime")) {
                populateSetPickupTime(hourOfDay, minute);
            }
            if (this.getTag().equals("DeliveryTime")) {
                populateSetDeliveryTime(hourOfDay, minute);
            }
        }

        public void populateSetPickupTime(int hour, int minute) {
            DateConvertClass oDate = new DateConvertClass();
            oDate.oContext = getActivity().getApplicationContext();
            etCreatePickupTime.setText(oDate.FormatTimeOnly(hour, minute));
        }

        public void populateSetDeliveryTime(int hour, int minute) {
            DateConvertClass oDate = new DateConvertClass();
            oDate.oContext = getActivity().getApplicationContext();
            etCreateDeliverTime.setText(oDate.FormatTimeOnly(hour, minute));
        }
    }

    private void getWeightType (Context oContext) {
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        //Open a database connection and get all of the hashes
        try {
            String sLanguage = Locale.getDefault().getLanguage();
            String sSQL = "";
            switch (sLanguage) {
                case "en":
                    sSQL = "select _id, Name_en from MeasurementTypes";
                    break;
                case "es":
                    sSQL = "select _id, Name_sp from MeasurementTypes";
                    break;
                default:
                    sSQL = "select _id, Name_en from MeasurementTypes";
            }
            oDB.createDataBase();
            oDB.openDataBase();
            ArrayList<ArrayList<String>> tableArray = oDB.selectRecordsFromDBList(sSQL, null);
            Integer iSize = tableArray.size();
            if (iSize > 0) {
                for (ArrayList<String> sTableValues : tableArray) {
                    String sId = sTableValues.get(0).toString();
                    String sDisplay = sTableValues.get(1).toString();
                    SpinnerObj oSpinner = new SpinnerObj(sId, sDisplay);
                    sSpinnerFieldList.add(oSpinner);
                };
            }
            //Add the default nothing entered value
            SpinnerObj oSpinner = new SpinnerObj("0", oContext.getResources().getString(R.string.create_job_spinner_hint));
            sSpinnerFieldList.add(0, oSpinner);
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } catch (SQLiteException ex) {
            DBLogs.insert("Sqlite Error: " + ex.toString(),
                    "CreateJobMainFragment.getWeightType", oContext,
                    sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
    }

    public Bundle createAndSave() {
        //Send captured data to parent activity
        Bundle bData = new Bundle();
        bData.putString("jobnumber", etCreateJobNumber.getText().toString());
        bData.putString("pickupdate", etCreatePickupDate.getText().toString());
        bData.putString("pickuptime", etCreatePickupTime.getText().toString());
        bData.putString("deliverdate", etCreateDeliverDate.getText().toString());
        bData.putString("delivertime", etCreateDeliverTime.getText().toString());
        bData.putString("customerrefnum", etCreateCustomerRefNum.getText().toString());
        bData.putString("containernum", etCreateContainerNum.getText().toString());
        bData.putString("entrynum", etCreateEntryNum.getText().toString());
        bData.putString("manifestnum", etCreateManifestNum.getText().toString());
        bData.putString("cargoweight", etCreateCargoWeight.getText().toString());
        SpinnerObj oSpinner = (SpinnerObj) spCreateCargoWeightType.getSelectedItem();
        bData.putString("cargoweighttype", oSpinner.getId());
        return bData;
    }
}