package com.exquisiteapplicationsolutions.tis;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.exquisiteapplicationsolutions.tis.objects.JobRow;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by John Nissley on 2/16/2017.
 */

public class jobRowArrayAdapter extends ArrayAdapter<JobRow> {
    private Context context;
    private List<JobRow> JobRows;
    //constructor, call on creation
    public jobRowArrayAdapter(Context context, int resource, ArrayList<JobRow> objects) {
        super(context, resource, objects);
        this.context = context;
        this.JobRows = objects;
    }

    //called when rendering the list
    public View getView(int position, View convertView, ViewGroup parent) {
        //get the property we are displaying
        View view = null;
        JobRow jobRow = JobRows.get(position);
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
        view = inflater.inflate(R.layout.jobs_row, null);
        LinearLayout row = (LinearLayout) view.findViewById(R.id.lo_job_row);
        switch (jobRow.getJobStatusID()) {
            case 5:
                row.setBackgroundColor(Color.YELLOW);
                break;
            case 4:
                row.setBackgroundColor(Color.GREEN);
                break;
            default:
                row.setBackgroundResource(R.color.LightGray);
        }
        TextView jobID = (TextView) view.findViewById(R.id.tvJobID);
        TextView jobDate = (TextView) view.findViewById(R.id.tvJobDate);
        TextView jobStatus = (TextView) view.findViewById(R.id.tvJobStatus);
        TextView jobManifest = (TextView) view.findViewById(R.id.tvJobManifest);
        TextView jobContainer = (TextView) view.findViewById(R.id.tvJobContainer);
        jobID.setText(jobRow.getJobID());
        jobDate.setText(jobRow.getJobDate());
        jobStatus.setText(jobRow.getJobStatus());
        jobManifest.setText(jobRow.getJobManifest());
        jobContainer.setText(jobRow.getJobContainer());
        return view;
    }
}
